﻿@inject ISystemsRepository SystemsRepository
@inject ISubSystemsRepository SubSystemsRepository

<MudGrid>
    <MudItem md="6">
        <MudSelect T="int" Label="システム" @bind-Value="SystemId" SelectedValuesChanged="SystemChanged" Dense="true">
            <MudSelectItem Value="@(0)">@(" ")</MudSelectItem>
            @foreach (var system in _systems)
            {
                <MudSelectItem Value="@(system.Id)">@system.CompartmentName</MudSelectItem>
            }
        </MudSelect>
    </MudItem>
    <MudItem md="6">
        <MudSelect T="int" Label="サブシステム" @bind-Value="SubSystemId" SelectedValuesChanged="SubSystemChanged" Dense="true">
            <MudSelectItem Value="@(0)">@(" ")</MudSelectItem>
            @foreach (var subSystem in _subSystems)
            {
                <MudSelectItem Value="@(subSystem.Id)">@subSystem.CompartmentName</MudSelectItem>
            }
        </MudSelect>
    </MudItem>
</MudGrid>

@code {
    [Parameter]
    public int SystemId { get; set; }
    [Parameter]
    public EventCallback<int> SystemIdChanged { get; set; }

    [Parameter]
    public int SubSystemId { get; set; }
    [Parameter]
    public EventCallback<int> SubSystemIdChanged { get; set; }

    private IEnumerable<SystemEntity> _systems = new List<SystemEntity>();
    private IEnumerable<SubSystemEntity> _subSystems = new List<SubSystemEntity>();

    protected override async Task OnInitializedAsync()
    {
        _systems = await SystemsRepository.GetAllSystems();
    }

    private async void SystemChanged()
    {
        if (SystemId == 0)
        {
            _subSystems = new List<SubSystemEntity>();
        }
        else
        {
            _subSystems = await SubSystemsRepository.GetSubSystemsBySystemId(SystemId);
        }
        SubSystemId = 0;
        await SystemIdChanged.InvokeAsync(SystemId);
        await SubSystemIdChanged.InvokeAsync(SubSystemId);
    }

    private async void SubSystemChanged()
    {
        await SubSystemIdChanged.InvokeAsync(SubSystemId);
    }
}